//--------------------------------------------------------------------------------------
// File: Textured.vs
//
// Copyright goes here...
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// Constant Buffer Variables
//--------------------------------------------------------------------------------------

cbuffer cbPerFrame : register( b0 )
{
	matrix View;		// This is the semantic
	matrix Projection;
};

cbuffer cbPerObject : register( b1 )
{
	matrix World;
};


//--------------------------------------------------------------------------------------
struct VS_INPUT
{
	float4 Pos  : POSITION;
	float3 Norm : NORMAL;
	float2 Tex  : TEXCOORD0;
};

struct PS_INPUT
{
	float4 Pos  : SV_POSITION;
	float3 Norm : TEXCOORD7;
	float2 Tex  : TEXCOORD0;
};


//--------------------------------------------------------------------------------------
// Vertex Shader
//--------------------------------------------------------------------------------------
PS_INPUT VS( VS_INPUT input )
{
	PS_INPUT output = (PS_INPUT)0;
	output.Pos = mul( input.Pos, World );
	output.Pos = mul( output.Pos, View );
	output.Pos = mul( output.Pos, Projection );
	output.Tex = input.Tex;
	
	output.Norm = mul(input.Norm, (float3x3)World);
	//output.Norm = abs( output.Norm );
	//output.Norm = input.Norm;
	
	// Wrapped lighting
	output.Norm = output.Norm * 0.5f + 0.5f;
	
	return output;
}